/*
The Unreal Engine is protected under the GPL.
For more information, please see http://www.epicgames.com/ut2k4_eula.html

Use and distribution of Gamebots is dictated by the terms in the GNU GPL.
http://www.gnu.org/licenses/gpl.html

Copyright 2006,  Joe Manolovich, Tim Garwood, Jessica Bayliss
*/


//=============================================================================
// RemoteBot.
// Basedon Bot class
//=============================================================================
class RemoteBot extends Bot
	config(BotAPI);


var config bool bDebug;

//maybe link to bot's periphreal vision? UT bots need much less of an arc though
//like Pawn's PeriphrealVision, this value should be the cosine of the limits
//of visual field. (i.e. 0.707 = 45 degrees to each side, or a 90* arc.)
var config float remoteVisionLimit;

//The socket to the agent
var BotConnection myConnection;


//The three remote vars compliment the my vars right below. The only one
//that ever needs to be duplicated is RemoteEnemy and myTarget
//just need RemoteDestination || myDestination and RFocus || myFocus

//Who the remote bot is trying to shoot at. Used by the aiming code.
var Actor RemoteEnemy;
//Thing the remote bot is trying to move to.
var Actor RemoteDestination;
//Thing the remote bot is looking at.
var Actor RemoteFocus;

//The spot the bot is shooting at
var vector myTarget;
//The spot the bot is moving to
var vector myDestination;
//The spot the bot is looking at
var vector myFocus;
// [change ut2003]
var rotator myRotationRate;
var float theta;
//

// time that last sent a WAL message
var float lastWallHitTime;

// time that last sent a BMP message
var float lastBumpTime;




// delimeters for strings sent to clients. set to match those of myConnection
// as = identifies the start of an attribute
var string as;
// ae = attribute end
var string ae;
// ib = item break
var string ib;


var rotator myRotation;
var config float deltatime;
var actor HitActor;
var vector HitNormal, HitLocation;

// called when using movetoward with bAdvancedTactics true to temporarily modify destination
event AlterDestination();

// Mover has notifies pawn that pawn is underneath it
function UnderLift(Mover M)
{
	// SENDMESSAGE
	// !!! possible new message
}

//Take a wild guess
function StartMatch()
{
	// SENDMESSAGE
	// !!! possible new message
}

//Called from weapon code when out of ammo or some such
//Don't call from local - weapon won't stop until ticked
function StopFiring()
{
	bFire = 0;
	bAltFire = 0;
}

//Use from local code - stops firing and ticks weapon to let it stop 
function HaltFiring()
{
	Pawn.Weapon.StopFire(Pawn.Weapon.BotMode);
	StopFiring();
	
	Pawn.Weapon.Tick(0.001);
}

 /* AIHearSound()
Called when AI controlled pawn would hear a sound.  Default AI implementation uses MakeNoise()
interface for hearing appropriate sounds instead

Update 1-2-06  Tim Garwood, Jessica Bayliss
Now sending HRN and HRP messages from this function if the source was of a certain type.
*/

event AIHearSound( actor Actor, int Id, sound S, vector SoundLocation, vector Parameters, bool Attenuate ) {

	if( Actor.IsA('Pickup') ) {

		myConnection.SendLine("HRP" $ib$as$
		"SourceClass" $ib$ actor.Class $ae$ib$as$
		"Name" $ib$ actor.Name $ae);
		//"Rotation" $ib$ rotator(Location - actor.Location) $ae);
	} else {
	       //revision 2-20-06  Tim Garwood
	       //sending unique player ID's here now, too. check for null controller because when a pawn dies
	       //this function still gets called sometimes
	       if( Actor.isA('Pawn') && Pawn(Actor).Controller != none) {

                   myConnection.sendLine("HRN" $ib$as$ "Source" $ib$ Pawn(Actor).Controller $
                                                       Pawn(Actor).Controller.PlayerReplicationInfo.PlayerID $ae);

                } else {

                 myConnection.SendLine("HRN" $ib$as$ "Source" $ib$ actor $ae);

                 //"Rotation" $ib$ rotator(Location - actor.Location) $ae);
		}
	}

}



//Change to what the bot is standing on
singular event BaseChange()
{
	local actor HitActor;
	local vector HitNormal, HitLocation;

	// !!! Can't handle shootable floors
	/*
	if ( Mover(Base) != None )
	{
		// handle shootable secret floors
		if ( Mover(Base).bDamageTriggered && !Mover(Base).bOpening
			&& (MoveTarget != None) )
		{
			HitActor = Trace(HitLocation, HitNormal, MoveTarget.Location, Location, true);
			if ( HitActor == Base )
			{
				Target = Base;
				bShootSpecial = true;
				FireWeapon();
				bFire = 0;
				bAltFire = 0;
				Base.Trigger(Base, Self);
				bShootSpecial = false;
			}
		}
	}
	else */
		Super(Pawn).BaseChange();

	// !!! possible SENDMESSAGE
}


                  

//Called right before bot falls off something
//If bot running, set bCanJump to true - let him fall
//if walking, won't fall
event MayFall()
{	
	local bool bFall;
	
	bFall = !Pawn.bIsWalking;
	
	if(!bfall)
	{
		GotoState('Startup', 'Begin');
	}

	myConnection.SendLine("FAL" $ib$as$ "Fell" $ib$ bFall $ae$ib$as$
							"Location" $ib$ Location $ae);

	Pawn.bCanJump = bFall;
}

function float GetSpeed()
{
    if(Pawn.bIsWalking)
    {
	    return Pawn.WalkingPct;
    }
    else
    {
	    return 1.0;
    }
}





//can be autocalled when bot is shot by team mate
function YellAt(Pawn Moron);





//called when get new item
function NotifyAddInventory( inventory NewItem )
{
	
	Super.NotifyAddInventory( NewItem );
	//Super(Pawn).AddInventory(NewItem);

	myConnection.SendLine("AIN" $ib$as$ "Id" $ib$ NewItem $ae$ib$as$
							"Class" $ib$ NewItem.Class $ae);
}





// !!! need functions to send arbitrary string messages

//functions to send tokenized messages
function SendTeamMessage(PlayerReplicationInfo Recipient, name MessageType, byte MessageID, float Wait)
{
	//log(self@"Send message"@MessageType@MessageID@"at"@Level.TimeSeconds);
	if ( (MessageType == OldMessageType) && (MessageID == OldMessageID)
		&& (Level.TimeSeconds - OldMessageTime < Wait) )
		return;

	//log("Passed filter");
	OldMessageID = MessageID;
	OldMessageType = MessageType;

	SendVoiceMessage(PlayerReplicationInfo, Recipient, MessageType, MessageID, 'TEAM');
}

function SendGlobalMessage(PlayerReplicationInfo Recipient, name MessageType, byte MessageID, float Wait)
{
	//log(self@"Send message"@MessageType@MessageID@"at"@Level.TimeSeconds);
	if ( (MessageType == OldMessageType) && (MessageID == OldMessageID)
		&& (Level.TimeSeconds - OldMessageTime < Wait) )
		return;

	//log("Passed filter");
	OldMessageID = MessageID;
	OldMessageType = MessageType;

	SendVoiceMessage(PlayerReplicationInfo, Recipient, MessageType, MessageID, 'GLOBAL');
}

function SendVoiceMessage(PlayerReplicationInfo Sender, PlayerReplicationInfo Recipient, name messagetype, byte messageID, name broadcasttype) {

         Super.SendVoiceMessage( Sender, Recipient, messageType, messageID, broadcasttype );

}

//events for recieving arbitrary string messages
event ClientMessage( coerce string S, optional name Type )
{
	myConnection.SendLine("VMS" $ib$as$ "String" $ib$ S $ae);
}

// while clientMessage is always global, a team message may be global or
// local depending on the message "type"
event TeamMessage( PlayerReplicationInfo PRI, coerce string S, name Type )
{
  if (string(Type) ~= "TeamSay")
	myConnection.SendLine("VMT" $ib$as$ "String" $ib$ S $ae);
  else // assume it's a global message
	myConnection.SendLine("VMS" $ib$as$ "String" $ib$ S $ae);
}

//added 2-13-06 Tim Garwood
//This function is for sending messages to teammates, it is getting called from BroadcastTeam
//because BroadcastHandler's only send team/global messages to PlayerControllers.
function SendMessageToTeam( string S ) {

  local Controller C;

  for( C = Level.ControllerList; C != None; C = C.NextController ) {

       //check for BotDeathMatch gametype first....
       if( C.PlayerReplicationInfo.Team != none ) {
           if( C.isA('RemoteBot') && C != self &&
               C.PlayerReplicationInfo.Team.TeamIndex == PlayerReplicationInfo.Team.TeamIndex) {

               RemoteBot(C).myConnection.sendLine("VMT" $ib$as$ "String" $ib$ S $ae);


           }

       }
  }
}


//added 2-13-06 Tim Garwood
//This function is for sending messages to everyone, it is getting called from BroadcastTeam
//because BroadcastHandler's only send team/global messages to PlayerControllers.

function SendMessageToEveryone( string S ) {

  local Controller C;
  for( C = Level.ControllerList; C != None; C = C.NextController ) {

         if( C.isA('RemoteBot') && C != self ) {

             RemoteBot(C).myConnection.sendLine("VMS" $ib$as$ "String" $ib$ S $ae);
         }
  }
}

//events for recieving tokenized voice message
function BotVoiceMessage(name messagetype, byte MessageID, Controller Sender)
{
	if (Sender.PlayerReplicationInfo.Team != PlayerReplicationInfo.Team)
		return;

        //modified 2-16-06 to send unique player ID as part of the string.
	myConnection.SendLine("VMG" $ib$as$ "Sender" $ib$ Sender $ Sender.PlayerReplicationInfo.PlayerID $ae$ib$as$
		"Type" $ib$ messagetype $ae$ib$as$
		"Id" $ib$ messageID $ae);
}

//
// Broadcast a message to all players, or all on the same team. This
// function allows bots to participate as players by calling the
// appropriate Player or RemoteBot controller function.
//
function TeamBroadcast( coerce string Msg)
{
  local Controller P;
  local bool bGlobal;

  // the @ sign means global by our choice
  if ( Left(Msg, 1) ~= "@" )
  {
    Msg = Right(Msg, Len(Msg)-1);
    bGlobal = true;
  } else bGlobal = false;

  //if ( Left(Msg, 1) ~= "." )
  //  Msg = "."$VoicePitch$Msg;

  if ( bGlobal || !Level.Game.bTeamGame )
  {
    //if ( Level.Game.AllowsBroadcast(self, Len(Msg)) )
    //  for ( P=Level.ControllerList; P!=None; P=P.NextController ) {
    //if( P.bIsPlayer  || P.IsA('MessagingSpectator') )
    //  P.TeamMessage( PlayerReplicationInfo, Msg, 'Say' );
    //}
    Level.Game.Broadcast(self, Msg, 'Say');

    //added 2-13-06  Tim Garwood
    //see SendMessageToEveryone for comment.
    sendMessageToEveryone( Msg );

  } else {

    Level.Game.BroadcastTeam(self, Msg, 'TeamSay');

     //added 2-13-06  Tim Garwood
     //see SendMessageToTeam for comment.
     SendMessageToTeam( Msg );

  //2-13-06  Tim Garwood
  //this code is like exactly what I wrote for SendMessageToTeam...

    //if ( Level.Game.AllowsBroadcast(self, Len(Msg)) )
    //for ( P=Level.ControllerList; P!=None; P=P.NextController ) {
    //  if( P.bIsPlayer && (P.PlayerReplicationInfo.Team == PlayerReplicationInfo.Team) )
    //  {
    //	  P.TeamMessage( PlayerReplicationInfo, Msg, 'TeamSay' );
    //  }
    //}
  }

}


//other code may try to call this. make sure nada happens
//!!! need to change - make sure orders are actually recorded somewhere
//             for reference
function SetOrders(name NewOrders, Controller OrderGiver);







/*
// !!! Allow for disabling of autoswitch???
function bool SwitchToBestWeapon()
{
	local float rating;
	local int usealt, favalt;
	local inventory MyFav;

	if ( Inventory == None ) {
		log("SwitchToBestWeapon - inventory is none, returning false.");
		return false;
	}

	PendingWeapon = Inventory.RecommendWeapon(rating, usealt);
	if ( PendingWeapon == None ) {
		log("SwitchToBestWeapon - pendingWeapon is none, returning false.");
		return false;
	}

	if ( (FavoriteWeapon != None) && (PendingWeapon.class != FavoriteWeapon) )
	{
		MyFav = FindInventoryType(FavoriteWeapon);
		if ( (MyFav != None) && (Weapon(MyFav).RateSelf(favalt) + 0.22 > PendingWeapon.RateSelf(usealt)) )
		{
			usealt = favalt;
			PendingWeapon = Weapon(MyFav);
		}
	}
	if ( Weapon == None ) {
		ChangedWeapon();
	}
	else if ( Weapon != PendingWeapon )
		Weapon.PutDown();

	return (usealt > 0);
}
*/







//events that are called when head, feet or whole bot changes zones
//e.g. air to water or lava
//only way to tell if underwater until drowning damage starts
/*
function FootZoneChange(ZoneInfo newFootZone)
{
	Super.FootZoneChange(newFootZone);

	myConnection.SendLine("ZCF" $ib$as$ "Id" $ib$ newFootZone $ae);
}

function HeadZoneChange(ZoneInfo newHeadZone)
{
	Super.HeadZoneChange(newHeadZone);

	myConnection.SendLine("ZCH" $ib$as$ "Id" $ib$ newHeadZone $ae);
}
*/

event bool NotifyHeadVolumeChange( PhysicsVolume NewVolume ) {

         myConnection.SendLine("ZCH" $ib$as$ "Id" $ib$ NewVolume $ae$ib$as$ "Pain" $ib$ NewVolume.bPainCausing $ae);
         return Super.NotifyHeadVolumeChange( NewVolume );

}

//[ut2003 change] - 2-15-06  Tim Garwood
//UT2003/4 Don't distinguish between foot volume changes and head volume changes, so we
//are only going to send the ZCF notification if the new volume is lava or water, because your
//feet would have to be in it if you made contact with it.
//should we send a different kind of message, since "zones" aren't really being used anymore?
//maybe something like VCF, VCH for foot/head and ZCB for body, since ZoneChange is still being used?
event bool NotifyPhysicsVolumeChange( PhysicsVolume NewVolume ) {

      if( NewVolume.isA('WaterVolume') || NewVolume.isA('LavaVolume') ) {
          myConnection.SendLine("ZCF" $ib$as$ "Id" $ib$ NewVolume $ae$ib$as$ "Pain" $ib$ NewVolume.bPainCausing $ae);
      } else {
          myConnection.SendLine("ZCB" $ib$as$ "Id" $ib$ NewVolume $ae$ib$as$ "Pain" $ib$ NewVolume.bPainCausing $ae);
         return Super.NotifyPhysicsVolumeChange( NewVolume );
      }

}
function ZoneChange(ZoneInfo newZone)
{
	Super.ZoneChange(newZone);

	if(myConnection != None) {
		myConnection.SendLine("ZCB" $ib$as$ "Id" $ib$ newZone $ae);
	}
}


//may want to hack into this for vision limits.
//used by existing bots to change fov based on activity.
/*function SetPeripheralVision()
{
	if ( bNovice )
	    PeripheralVision = 0.7;
	else if ( Skill == 3 )
	    PeripheralVision = -0.2;
	else
	    PeripheralVision = 0.65 - 0.33 * skill;

	PeripheralVision = FMin(PeripheralVision - BaseAlertness, 0.9);

	Pawn.SightRadius = Pawn.Default.SightRadius;
}*/





//commented out 1-6-06 Tim Garwood, might not be needed.
//overriden to avoid bot version which can goto state 'findair'
/*
function PainTimer()
{
	local float depth;
	if (Pawn.Health <= 0)
		return;

	/*if (FootRegion.Zone.bPainZone)
		Super(Pawn).PainTimer();
	else if (HeadRegion.Zone.bWaterZone)
	{
		if (bDrowning)
			self.TakeDamage(5, None, Location + CollisionHeight * vect(0,0,0.5), vect(0,0,0), 'Drowned');
		
		if (Pawn.Health > 0)
			PainTime = 2.0;
	} */ // FIXME
}	
*/







//Called when weapon is switched - may happen automatically
function ChangedWeapon()
{
	
	local int usealt;
	if ( Pawn.Weapon != None && Pawn.Weapon == Pawn.PendingWeapon )
	{
			SwitchToBestWeapon();
		if ( Pawn.Weapon.GetStateName() == 'DownWeapon' ) 
			Pawn.Weapon.GotoState('Idle');
		Pawn.PendingWeapon = None;
	}
	else
		Super(Pawn).ChangedWeapon();

	if ( Pawn.Weapon != None )
	{
		if (bFire > 0)
		{
 			bAltFire = 0;
			bFire = 1;
			Pawn.weapon.Fire(1.0);
		}
 		else if (bAltFire > 0)
 		{
			bAltFire = 0;
			bFire = 1;
			Pawn.Weapon.AltFire(1.0);
		}
		Pawn.Weapon.SetHand(0);
		// Weapon.FireOffset.Y = 0;
	}
	// !!! use or just make people get from status update
	if(Pawn.Weapon == None)
		myConnection.SendLine("CWP" $ib$as$ "Id" $ib$ "None" $ae$ib$as$
							"Class" $ib$ "None" $ae);
	else 
		myConnection.SendLine("CWP" $ib$as$ "Id" $ib$ Pawn.Weapon $ae$ib$as$
							"Class" $ib$ Pawn.Weapon.Class $ae);
}


// called from pathnodes that unitelligent creatures are supposed to avoid
function FearThisSpot(AvoidMarker aSpot);




event Touch( Actor Other )
{
	myConnection.SendLine("Touched " $Other);
}


//called on hitting a wall
event bool NotifyHitWall(vector HitNormal, actor HitActor)
{
	if ( Level.TimeSeconds - 0.5 >= lastWallHitTime ) 
	{
		myConnection.SendLine("WAL" $ib$as$ "Id" $ib$ HitActor $ae$ib$as$
			"Normal" $ib$ HitNormal $ae$ib$as$
			"Location" $ib$ Location $ae);

		lastWallHitTime = Level.TimeSeconds;
	}
	return true;
}

//called on collisions with other actors
event bool NotifyBump(Actor Other)
{

	local vector VelDir, OtherDir;
	local float speed, dist;

	//log("RemoteBot NotifyBump Other:"$Other);
	if ( TimerRate <= 0 )
		setTimer(1.0, false);

	speed = VSize(Velocity);
	if ( speed > 10 )
	{
		VelDir = Velocity/speed;
		VelDir.Z = 0;
		OtherDir = Other.Location - Location;
		OtherDir.Z = 0;
		OtherDir = Normal(OtherDir);
		if ( (VelDir Dot OtherDir) > 0.8 )
		{
			Velocity.X = VelDir.Y;
			Velocity.Y = -1 * VelDir.X;
			Velocity *= FMax(speed, 280);
		}
	}

	if ( Level.TimeSeconds - 0.5 >= lastBumpTime )
	{
	   if( Other.isA('Pawn')) {

              myConnection.SendLine("BMP" $ib$as$ "Id" $ib$ Pawn(Other).Controller $ Pawn(Other).Controller.PlayerReplicationInfo.PlayerID
                                          $ae$ib$as$ "Location" $ib$ Other.Location $ae);

	   } else {
		myConnection.SendLine("BMP" $ib$as$ "Id" $ib$ Other $ae$ib$as$
			"Location" $ib$ Other.Location $ae);
           }
		lastBumpTime = Level.TimeSeconds;
	}


	/*
	* Revision:  12-15-05  Tim Garwood
	turned off the Disable('NotifyBump') function call so bots know when they bumped into
	something more than once.
	*/
	//Need to disable bumping???
	//Disable('Bump');
	//Disable('NotifyBump');
	return false;
}





/*commented out 1-6-06  Tim Garwood, might not be needed.
function SetFall()
{
	//SENDMESSAGE
/*
	if (Enemy != None)
	{
		TweenToFalling();
		NextAnim = AnimSequence;
		GotoState('FallingState');
	}*/ // FIXME
}
*/



function LongFall()
{
	// SENDMESSAGE ???
}

// 1-20-06 Tim Garwood - we might need this stupid little override because if a RemoteBot hears a noise it will 
//start to perform in ways that it was not meant to , a.k.a the server claims it and it becomes really really good.
function HearNoise(float Loudness, Actor NoiseMaker) { }


//called periodicaly for each player in view
function SeePlayer(Pawn SeenPlayer)
{
    if(SeenPlayer == None) {
	return;
    }
    
    myConnection.SendLine("SEE" $ib$as$ "Id" $ib$ SeenPlayer $ae$ib$as$
			  "Rotation" $ib$ SeenPlayer.Rotation $ae$ib$as$ 
			  "Location" $ib$ SeenPlayer.Location $ae$ib$as$
			  "Velocity" $ib$ SeenPlayer.Velocity $ae$ib$as$
			  "Name" $ib$ SeenPlayer.PlayerReplicationInfo.PlayerName $ae$ib$as$
			  "Team" $ib$ SeenPlayer.PlayerReplicationInfo.Team.TeamIndex $ae$ib$as$ 
			  "Reachable" $ib$ actorReachable(SeenPlayer) $ae$ib$as$ 
			  "Weapon" $ib$ SeenPlayer.Weapon $ae);
}






/* FindBestPathToward() assumes the desired destination is not directly reachable,
given the creature's intelligence, it tries to set Destination to the location of the
best waypoint, and returns true if successful
*/
/*
function bool FindBestPathToward(actor desired, bool bClearPaths)
{
	local Actor path;
	local bool success;

	if ( specialGoal != None)
		desired = specialGoal;
	path = None;
	path = FindPathToward(desired,,bClearPaths);

	success = (path != None);
	if (success)
	{
		MoveTarget = path;
		Destination = path.Location;
	}
	return success;
}
*/




/* NearWall() returns true if there is a nearby barrier at eyeheight, and
changes Focus to a suggested value
*/
//Potentially usefull
/*
function bool NearWall(float walldist)
{
	local actor HitActor;
	local vector HitLocation, HitNormal, ViewSpot, ViewDist, LookDir;

	LookDir = vector(Rotation);
	ViewSpot = Location + BaseEyeHeight * vect(0,0,1);
	ViewDist = LookDir * walldist;
	HitActor = Trace(HitLocation, HitNormal, ViewSpot + ViewDist, ViewSpot, false);
	if ( HitActor == None )
		return false;

	ViewDist = Normal(HitNormal Cross vect(0,0,1)) * walldist;
	if (FRand() < 0.5)
		ViewDist *= -1;

	if ( FastTrace(ViewSpot + ViewDist, ViewSpot) )
	{
		Focus = Location + ViewDist;
		return true;
	}

	ViewDist *= -1;

	if ( FastTrace(ViewSpot + ViewDist, ViewSpot) )
	{
		Focus = Location + ViewDist;
		return true;
	}

	Focus = Location - LookDir * 300;
	return true;
}
*/




// Largely untested
function RemoteJump()
{
  Pawn.DoJump(true);
}






//Intercept FireWeapon - is called from other code
function FireWeapon();

function RemoteFireWeapon(bool bUseAltMode)
{
	if ( !bUseAltMode )
	{
		bFire = 1;
		bAltFire = 0;
    	Pawn.Weapon.BotMode = 0;
    	Pawn.Weapon.StartFire(0);
	}
	else
	{
		bFire = 0;
		bAltFire = 1;
    	Pawn.Weapon.BotMode = 1;
    	Pawn.Weapon.StartFire(1);
	}
}

// check for line of sight to target deltatime from now.
//used by missle launcher and others to abort firing
// may want to reimplement
function bool CheckFutureSight(float deltatime)
{
	return true;
}

/*
Adjust the aim at target.
	- add aim error
	- adjust up or down if barrier
Must set RemoteTarget elsewhere
*/
/*
Commented out, deleted 1-6-06  Tim Garwood
Could probably just use superclass version.

function vector AdjustToss(float projSpeed, vector projStart, vector End, bool bNormalize)
{
}
*/

function rotator AdjustAim(FireProperties FiredAmmunition, vector projStart, int aimerror)
{
	local rotator FireRotation, TargetLook;
	local float FireDist, TargetDist, ProjSpeed;
	local actor HitActor;
	local vector FireSpot, FireDir, TargetVel, HitLocation, HitNormal;
	local int realYaw;
	local bool bDefendMelee, bClean, bLeadTargetNow;

	if ( FiredAmmunition.ProjectileClass != None )
		projspeed = FiredAmmunition.ProjectileClass.default.speed;

	// make sure bot has a valid target
	if ( Target == None )
	{
		Target = Enemy;
		if ( Target == None ) {
		   
		     //we are shooting at a location - 2-16-06  Tim Garwood
                        SetRotation( Rotator( myFocus ));
                        
                        FireSpot = myFocus;
	                TargetDist = VSize(myFocus - Pawn.Location);

	                // perfect aim at stationary objects
	                if ( Pawn(Target) == None ) {
		          if ( !FiredAmmunition.bTossed )
			     return rotator(myFocus - projstart);
		          else {
			  FireDir = AdjustToss(projspeed,ProjStart, myFocus ,true);
			  SetRotation(Rotator(FireDir));
                          UpdatePawnViewPitch();
		          return Rotation;
		          }
	                }
               }
        }

        //target defined

        FireSpot = Target.Location;
	TargetDist = VSize(Target.Location - Pawn.Location);

	// perfect aim at stationary objects
	if ( Pawn(Target) == None )
	{
		if ( !FiredAmmunition.bTossed )
			return rotator(Target.Location - projstart);
		else
		{
			FireDir = AdjustToss(projspeed,ProjStart,Target.Location,true);
			SetRotation(Rotator(FireDir));
            UpdatePawnViewPitch();
			return Rotation;
		}					
	}

	bLeadTargetNow = FiredAmmunition.bLeadTarget && bLeadTarget;
	bDefendMelee = ( (Target == Enemy) && DefendMelee(TargetDist) );
	aimerror = AdjustAimError(aimerror,TargetDist,bDefendMelee,FiredAmmunition.bInstantHit, bLeadTargetNow);

	// lead target with non instant hit projectiles
	if ( bLeadTargetNow )
	{
		TargetVel = Target.Velocity;
		// hack guess at projecting falling velocity of target
		if ( Target.Physics == PHYS_Falling )
		{
			if ( Target.PhysicsVolume.Gravity.Z <= Target.PhysicsVolume.Default.Gravity.Z )
				TargetVel.Z = FMin(TargetVel.Z + FMax(-400, Target.PhysicsVolume.Gravity.Z * FMin(1,TargetDist/projSpeed)),0);
			else
				TargetVel.Z = FMin(0, TargetVel.Z);
		}
		// more or less lead target (with some random variation)
		FireSpot += FMin(1, 0.7 + 0.6 * FRand()) * TargetVel * TargetDist/projSpeed;
		FireSpot.Z = FMin(Target.Location.Z, FireSpot.Z);

		if ( (Target.Physics != PHYS_Falling) && (FRand() < 0.55) && (VSize(FireSpot - ProjStart) > 1000) )
		{
			// don't always lead far away targets, especially if they are moving sideways with respect to the bot
			TargetLook = Target.Rotation;
			if ( Target.Physics == PHYS_Walking )
				TargetLook.Pitch = 0;
			bClean = ( ((Vector(TargetLook) Dot Normal(Target.Velocity)) >= 0.71) && FastTrace(FireSpot, ProjStart) );
		}
		else // make sure that bot isn't leading into a wall
			bClean = FastTrace(FireSpot, ProjStart);
		if ( !bClean)
		{
			// reduce amount of leading
			if ( FRand() < 0.3 )
				FireSpot = Target.Location;
			else
				FireSpot = 0.5 * (FireSpot + Target.Location);
		}
	}

	bClean = false; //so will fail first check unless shooting at feet  
	if ( FiredAmmunition.bTrySplash && (Pawn(Target) != None) && ((Skill >=4) || bDefendMelee) 
		&& (((Target.Physics == PHYS_Falling) && (Pawn.Location.Z + 80 >= Target.Location.Z))
			|| ((Pawn.Location.Z + 19 >= Target.Location.Z) && (bDefendMelee || (skill > 6.5 * FRand() - 0.5)))) )
	{
	 	HitActor = Trace(HitLocation, HitNormal, FireSpot - vect(0,0,1) * (Target.CollisionHeight + 6), FireSpot, false);
 		bClean = (HitActor == None);
		if ( !bClean )
		{
			FireSpot = HitLocation + vect(0,0,3);
			bClean = FastTrace(FireSpot, ProjStart);
		}
		else 
			bClean = ( (Target.Physics == PHYS_Falling) && FastTrace(FireSpot, ProjStart) );
	}
	if ( Pawn.Weapon.bSniping && Stopped() && (Skill > 5 + 6 * FRand()) )
	{
		// try head
 		FireSpot.Z = Target.Location.Z + 0.9 * Target.CollisionHeight;
 		bClean = FastTrace(FireSpot, ProjStart);
	}
	
	if ( !bClean )
	{
		//try middle
		FireSpot.Z = Target.Location.Z;
 		bClean = FastTrace(FireSpot, ProjStart);
	}
	if ( FiredAmmunition.bTossed && !bClean && bEnemyInfoValid )
	{
		FireSpot = LastSeenPos;
	 	HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false);
		if ( HitActor != None )
		{
			bCanFire = false;
			FireSpot += 2 * Target.CollisionHeight * HitNormal;
		}
		bClean = true;
	}

	if( !bClean ) 
	{
		// try head
 		FireSpot.Z = Target.Location.Z + 0.9 * Target.CollisionHeight;
 		bClean = FastTrace(FireSpot, ProjStart);
	}
	if ( !bClean && (Target == Enemy) && bEnemyInfoValid )
	{
		FireSpot = LastSeenPos;
		if ( Pawn.Location.Z >= LastSeenPos.Z )
			FireSpot.Z -= 0.4 * Enemy.CollisionHeight;
	 	HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false);
		if ( HitActor != None )
		{
			FireSpot = LastSeenPos + 2 * Enemy.CollisionHeight * HitNormal;
			if ( Pawn.Weapon.SplashDamage() && (Skill >= 4) )
			{
			 	HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false);
				if ( HitActor != None )
					FireSpot += 2 * Enemy.CollisionHeight * HitNormal;
			}
			if ( Pawn.Weapon.RefireRate() < 0.99 )
				bCanFire = false;
		}
	}

	// adjust for toss distance
	if ( FiredAmmunition.bTossed )
		FireDir = AdjustToss(projspeed,ProjStart,FireSpot,true);
	else
		FireDir = FireSpot - ProjStart;
	
	FireRotation = Rotator(FireDir);
	realYaw = FireRotation.Yaw;
	
	//ut2004 change - Tim Garwood	
	//This function's parameters have changed between 2003 and 2004. Consequently, 
	//FiredAmmunition is now a FireProperties object. WarnTarget is not part of FireProperties
	//anymore so we have to warn the target ourselves with ReceiveWarning

	if( Enemy != none && !FiredAmmunition.bInstantHit) {
		log("sending a warning");
		Enemy.Controller.ReceiveWarning( Pawn, FiredAmmunition.ProjectileClass.Default.Speed, vector(FireRotation)); 

	}
	//FiredAmmunition.WarnTarget(Target,Pawn,vector(FireRotation));

	FireRotation.Yaw = SetFireYaw(FireRotation.Yaw + aimerror);
	FireDir = vector(FireRotation);
	// avoid shooting into wall
	FireDist = FMin(VSize(FireSpot-ProjStart), 400);
	FireSpot = ProjStart + FireDist * FireDir;
	HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false); 
	if ( HitActor != None )
	{
		if ( HitNormal.Z < 0.7 )
		{
			FireRotation.Yaw = SetFireYaw(realYaw - aimerror);
			FireDir = vector(FireRotation);
			FireSpot = ProjStart + FireDist * FireDir;
			HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false); 
		}
		if ( HitActor != None )
		{
			FireSpot += HitNormal * 2 * Target.CollisionHeight;
			if ( Skill >= 4 )
			{
				HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false); 
				if ( HitActor != None )
					FireSpot += Target.CollisionHeight * HitNormal; 
			}
			FireDir = Normal(FireSpot - ProjStart);
			FireRotation = rotator(FireDir);		
		}
	}

	SetRotation(FireRotation);
    UpdatePawnViewPitch();
	return FireRotation;
}

//ut2004 change - 2-24-06  Tim Garwood
//overriding this function to call ReceiveWarning so that the PRJ message gets sent to the bots
//when projectiles are coming their way.

function ReceiveProjectileWarning(Projectile proj)
{
		ReceiveWarning(Proj.Instigator, Proj.speed, Normal(Proj.Velocity));
}

// Let Bot know about incoming projectiles
//revision 2-20-06  Tim Garwood
//changed this function to ReceiveWarning, which is what is called when a projectile is coming
//new to ut2003/4 - WarnTarget is part of Ammunition now.
function ReceiveWarning(Pawn shooter, float projSpeed, vector FireDir)
{

	local float enemyDist;
	local vector X,Y,Z, enemyDir;
	
	// AI controlled creatures may duck if not falling
	if ( (Pawn.health <= 0) || (Enemy == None)
		|| (Physics == PHYS_Falling) || (Physics == PHYS_Swimming) )
		return;

	/*if ( bNovice )
	{
		if ( FRand() > 0.11 * skill )
			return;
	}*/
	//else if ( FRand() > 0.22 * skill + 0.33 )
	if ( FRand() > 0.22 * skill + 0.33 )
		return;

	// and projectile time is long enough
	//enemyDist = VSize(shooter.Location - Location);
	
        //revision 2-23-06  Tim Garwood
        //calculate distance based on shooter's location and our pawn's position, not the controller.
	enemyDist = VSize( shooter.Location - Pawn.Location );
        if (enemyDist/projSpeed < 0.11 + 0.15 * FRand())
		return;

	// only if tight FOV
	GetAxes(Rotation,X,Y,Z);
	//enemyDir = (shooter.Location - Location)/enemyDist;
	
	//revision 2-23-06  Tim Garwood
        //calculate direction based on shooter's location and our pawn's position, not the controller.
	enemyDir = (shooter.Location - Pawn.Location)/enemyDist;
        if ((enemyDir Dot X) < 0.8)
		return;

	myConnection.SendLine("PRJ" $ib$as$ "Time" $ib$ (enemyDist/projSpeed) $ae$ib$as$
		"Direction" $ib$ rotator(enemyDir) $ae);
}

function WarnTarget(Pawn shooter, float projSpeed, vector FireDir)
{
	local float enemyDist;
	local vector X,Y,Z, enemyDir;

	// AI controlled creatures may duck if not falling
	if ( (Pawn.health <= 0) || (Enemy == None)
		|| (Physics == PHYS_Falling) || (Physics == PHYS_Swimming) )
		return;

	/*if ( bNovice )
	{
		if ( FRand() > 0.11 * skill )
			return;
	}*/
	//else if ( FRand() > 0.22 * skill + 0.33 )
	if ( FRand() > 0.22 * skill + 0.33 )
		return;

	// and projectile time is long enough
	enemyDist = VSize(shooter.Location - Location);
	if (enemyDist/projSpeed < 0.11 + 0.15 * FRand())
		return;

	// only if tight FOV
	GetAxes(Rotation,X,Y,Z);
	enemyDir = (shooter.Location - Location)/enemyDist;
	if ((enemyDir Dot X) < 0.8)
		return;

	myConnection.SendLine("PRJ" $ib$as$ "Time" $ib$ (enemyDist/projSpeed) $ae$ib$as$
		"Direction" $ib$ rotator(enemyDir) $ae);
}






function bool TryToDuck(vector duckDir, bool bReversed);





// CloseToPointMan - called if orders are 'follow' to check if close enough to point man
function bool CloseToPointMan(Pawn Other)
{
	//return what engine wants to hear
	return true;
}





//Don't need our bots autotaunting
function MaybeTaunt(Pawn Other);





//Called when someone other than this bot dies.
function Killed(pawn Killer, pawn Other, name damageType)
{

	local Pawn aPawn;
	if ( Killer == self )
		Other.Health = FMin(Other.Health, -11); // don't let other do stagger death

	if ( Pawn.Health <= 0 )
		return;

	if ( OldEnemy == Other )
		OldEnemy = None;

	if ( Enemy == Other )
	{
		Enemy = None;
	}
 
      /*
	myConnection.SendLine("KIL" $ib$as$ "Id" $ib$ Other $ae$ib$as$
		"Killer" $ib$ Killer $ae$ib$as$
		"DamageType" $ib$ damageType $ae);

      */

      //revision 2-20-06  Tim Garwood
      //sending unique player ID's and ID #'s for proper identification on the client side
      myConnection.SendLine("KIL" $ib$as$ "Id" $ib$ Other.Controller $ Other.Controller.PlayerReplicationInfo.PlayerID $ae$ib$as$
                                          "Killer" $ib$ Killer.Controller $ Killer.Controller.PlayerReplicationInfo.PlayerID $ae$ib$as$
                                          "DamageType" $ib$ damageType $ae);
}





//Pointless callback
function EnemyAcquired();






//All kinds of shit can call this mostly special trigger points
function Trigger( actor Other, pawn EventInstigator )
{
	 //SENDMESSAGE
}






//Much of translocator brains implemented in translocator
//For now better off playing without it - need to research how
//it interacts with path finding
function TranslocateToTarget(Actor Destn)
{
	//MyTranslocator.DesiredTarget = Destn;
}

//Don't let engine pick nodes that must be impact jumped
function bool CanImpactJump()
{
	return false;
}

//Don't handle impact jumps or low gravity manuevers for bots
function ImpactJump();
function BigJump(Actor JumpDest);

//Don't have engine direct to Ambush
function bool FindAmbushSpot()
{
	return false;
}

/*
function PawnDied(Pawn P)
{
	Pawn.UnPossessed();
	//Pawn = None;
	Super.PawnDied(P);

	//Revision:  12-12-05  Tim Garwood
	//uncommented the if statement, the call to spawnplayer and the call to gotostate to see if
	//bot will respawn.
	//update - bot respawns but seems to be alot dumber, doesn't send the runto message properly so it
	//keeps running into walls and other times it just doesn't move at all.
	//might be a problem on the client side with bot restarting itself?
	
	if(!IsInState('Dying'))
		BotDeathMatch(Level.Game).SpawnPlayer(self);
	GotoState('Dying');
	
	
	//Revision: 12-12-05  Tim Garwood
	//changed this code to BotDeathMatch(Level.Game).RestartPlayer(self) because we are playing botdeathmatch.
	//Level.Game.RestartPlayer(self);
	BotDeathMatch(Level.Game).RestartPlayer(self);
	
}
*/

//Called when bot dies
// function PawnDied() ???
/*
function Died(Controller Killer, class<DamageType>damageType, vector HitLocation)
{
	log("BOT DIED!!!!!!!!!!!");

	Pawn.Died(Killer, damageType, HitLocation);

	myConnection.SendLine("DIE" $ib$as$ "Killer" $ib$ Killer $ae$ib$as$
		"DamageType" $ib$ damageType $ae);


}
*/


//Called when bot is injured
function NotifyTakeHit(pawn InstigatedBy, vector HitLocation, int Damage,
	class<DamageType> damageType, vector Momentum)
{
	local float enemyDist;
	local vector enemyDir, X, Y, Z;
	local string messageString;
	
	Super.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	
	messageString = "DAM" $ib$as$ "Damage" $ib$ Damage $ae$ib$as$ "DamageType" $ib$ damageType $ae;
	
	// !!! need to fix this and projectile detection to match our
	//periphreal vision parameter.
	// only if tight FOV
	GetAxes(Rotation,X,Y,Z);
	enemyDist = VSize(instigatedBy.Location - Location);
	enemyDir = (instigatedBy.Location - Location)/enemyDist;
	//revision 2-20-06  Tim Garwood
	//sending unique player ID and player ID # for proper identification on client side.
	if ((enemyDir Dot X) > 0.8)
		messageString = messageString $ib$as$ "Instigator" $ib$ instigatedBy.Controller 
                              $ instigatedBy.Controller.PlayerReplicationInfo.PlayerID $ae;

	myConnection.SendLine(messageString);
	

	//revision 2-20-06  Tim Garwood
	//HurtOther doesn't get called in ut2003 so we need to send the "HIT" message to the instigator here
        //hack???
	if( InstigatedBy.Controller != none && InstigatedBy.Controller.isA('RemoteBot')) {

	    RemoteBot(InstigatedBy.Controller).myConnection.sendLine("HIT" $ib$as$ "Id" $ib$ self $
                 PlayerReplicationInfo.PlayerID $ae$ib$as$ "Damage" $ib$ Damage $ae$ib$as$
                 "DamageType" $ib$ DamageType $ae);

        }
}


//**********************************************************************************
//Base Monster AI

/*
auto state StartUp
{
	function BeginState()
	{
		SetMovementPhysics();
		if (Physics == PHYS_Walking)
			SetPhysics(PHYS_Falling);
	}

Begin:
}
*/

auto state StartUp
{ 

	
	function BeginState()
	{

	//Squad = spawn(BotDeathMatch(Level.Game).DMSquadClass(class<SquadAI>));

        //Revision 1-30-06  Tim Garwood
        //this is how Squads are spawned in DeathMatch.uc...
	Squad = spawn(class'DMSquad');
	if( Squad == none )
	    log("SQUAD IS NONE IN STARTUP!");

        //	Squad = spawn(DeathMatch(Level.Game).DMSquadClass); // FIXME
		Squad.AddBot(self);
		// Above is a blatant hack because I don't understand why this
		// won't work in AddRemoteBot
		//[work?]
		//SetMovementPhysics();
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, class<DamageType> damageType)	
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	}

	function Landed(vector HitNormal)
	{
		Global.Landed(HitNormal);
	} 
Begin:
	if (Physics != PHYS_Falling)
	{
		Velocity = vect(0,0,0);
		Acceleration = vect(0,0,0);
		MoveTimer = -1.0;
	}
	//Pawn.PlayWaiting();
	sleep( 30 );
	goto 'Begin';
Test:
	bFire = 0;
	RemoteEnemy=none;
	Enemy=none;
	//PlayDuck();
	sleep( 30 );
	goto 'Test';
Move:

	if( pawn != none ) {
	MoveTo(myDestination, , Pawn.bIsWalking);
	if( VSize(Pawn.Location - myDestination) > CollisionRadius )
	{
	    goto 'Move';
	}
	}// else {
	//	log("PAWN IS NONE IN MOVE STATE!!!!");
		//revision: 12-9-05  Tim Garwood
		//otherwise respawn?
	//	Squad = spawn(BotDeathMatch(Level.Game).DMSquadClass);
	//}
	goto 'Begin';
Strafe:

	/* Update 1-25-06  Tim Garwood
	Strafe seems to be working now. UT2003 has a MoveTo function that allows you to
	be looking at one spot while moving toward another (aka strafing). I added this
	function in here so the bot will be looking at its enemy while moving toward whatever
	destination it sent in the "STRAFE" message.
	*/

       /* if(RemoteFocus != none) {
	    Focus = RemoteFocus;
	} else if(myFocus != vect(0,0,0)) {
	    FocalPoint = myFocus;
	}*/


	//this is what i changed on 1-25-06 for strafing.... - TG
	MoveTo( Destination, Focus , false );

	if( VSize(Location - myDestination) > CollisionRadius )
		goto 'Strafe';

	goto 'Begin';
Tracking:

	if (Physics != PHYS_Falling)
	{
	    Velocity = vect(0,0,0);
	    Acceleration = vect(0,0,0);
	    MoveTimer = -1.0;
	}
	if ( RemoteFocus == none || !FastTrace(RemoteFocus.Location) )
	{
	    goto 'Begin';
	}
	else 
	{
	    Focus = RemoteFocus;

	    Sleep(0.05);
	    goto 'Tracking';
	}
Turning:	

	if (Pawn.Physics != PHYS_Falling)
	{
		Velocity = vect(0,0,0);
		Acceleration = vect(0,0,0);
		MoveTimer = -1.0;
	}

	if(myRotationRate != rot(0,0,0)) {
	    Pawn.RotationRate = myRotationRate;
	}
	/*
	//this code is causing the bot to look upward as it shoots!!!!! - Tim Garwood 1-25-06
	theta = 0.0;
	if(RemoteFocus != none) {
		log("Turning 1");
	  Focus = RemoteFocus;
	  theta = (Normal(Focus.Location) dot Normal(Pawn.Location));
	  theta = theta * 128;
	  theta = theta + 128;
	  Pawn.ViewPitch = byte(theta);
	} else if(myFocus != vect(0,0,0)) {
		log("Turning 2");
	  FocalPoint = myFocus;
	  theta = (Normal(FocalPoint) dot Normal(Pawn.Location));
	  theta = theta * 128;
	  theta = theta + 128;
	  Pawn.ViewPitch = byte(theta);
	} else if(myRotation != rot(0,0,0)) {
		log("Turning 3");
	  theta = (myRotation.Pitch / 256) % 256;
	  Pawn.ViewPitch = byte(theta);

	  ClientSetRotation(myRotation);

	} else {
		log("Turning 4");
	  goto 'Begin';
	}
	*/
	FinishRotation();

	/* Reset rotation rate to default value */
	if(myRotationRate != rot(0,0,0)) {
	    myRotationRate = rot(0,0,0);
	    Pawn.RotationRate = Pawn.default.RotationRate;
	}

	Sleep(0.05);
	goto 'Begin'; 
}


state TakeHit
{
	//ignores seeplayer, hearnoise, bump, hitwall;

	function Timer();

Begin:
	error("!!!TakeHit");
	//GotoState(NextState,NextLabel);
}

state GameEnded
{
//ignores SeePlayer, EnemyNotVisible, HearNoise, TakeDamage, Died, Bump, Trigger, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget;//, PainTimer;
ignores SeePlayer, EnemyNotVisible, HearNoise, TakeDamage, Bump, Trigger, HitWall, ZoneChange, Falling, WarnTarget, ReceiveWarning;//, PainTimer;

	function SpecialFire()
	{
	}
	function bool TryToDuck(vector duckDir, bool bReversed)
	{
	}
	function SetFall()
	{
	}
	function LongFall()
	{
	}
	function Killed(pawn Killer, pawn Other, name damageType)
	{
	}
	function ClientDying(class<DamageType> DamageType, vector HitLocation)
	{
	}

	function BeginState()
	{
		Pawn.SimAnim.AnimRate = 0.0;
		bFire = 0;
		bAltFire = 0;
		//SimAnim.Y = 0;
		SetCollision(false,false,false);
		SetPhysics(PHYS_None);
		Velocity = vect(0,0,0);
		myConnection.SendLine("FIN");
	}
}


state Dying
{
//ignores SeePlayer, EnemyNotVisible, HearNoise, Died, Bump, Trigger, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, LongFall, SetFall, PainTimer;
//ignores SeePlayer, EnemyNotVisible, HearNoise, Died, Bump, Trigger, HitWall, ZoneChange, Falling, WarnTarget, LongFall, SetFall, PainTimer;
ignores Trigger, Bump, HitWall, HeadVolumeChange, PhysicsVolumeChange, Falling;
	function ReStartPlayer()
	{
		log("DYING, RESTARTPLAYER");
		Velocity = vect(0,0,0);
		Acceleration = vect(0,0,0);
		//ViewRotation = Rotation;
		//SetRotation(Rotation);
		ReSetSkill();
		SetPhysics(PHYS_Falling);
		//SetOrders(BotReplicationInfo(PlayerReplicationInfo).RealOrders, BotReplicationInfo(PlayerReplicationInfo).RealOrderGiver, true); // FIXME
		//GotoState('StartUp');

		//Revision:  12-9-05  Tim Garwood
		//The wiki says that when you call restartPlayer on a pawn, the function actually calls
		//restart player on the game first?
		
		//pawn.restartplayer();
		//ServerReStartPlayer();
		//Level.Game.ReStartPlayer(self);
		//BotDeathMatch(Level.Game).RestartPlayer(self);
		// FIXME
		//BotDeathMatch(Level.Game).SpawnPlayer(self);

		if ( !IsInState('GameEnded') )
		{
			//log("not game ended, restart player");
			GotoState('Dying', 'TryAgain');
		}
	}

	function BeginState()
	{
		Enemy = None;
		// [work]
		//PointDied = -1000; // FIXME
		bFire = 0;
		bAltFire = 0;
		bInitLifeMessage = false;
		//MyTranslocator = None; // FIXME
		log("DYING, BEGINSTATE");
	}


Begin:
	if ( Level.Game.bGameEnded )
		GotoState('GameEnded');
	Sleep(0.2);
	//log("DYING, BEGIN");
TryAgain:
	// [work]
	//if ( !bHidden )
	//{
	//	HidePlayer();
	//} // FIXME
	Sleep(0.25 + DeathMatch(Level.Game).SpawnWait(self));
	log("DYING, TRYAGAIN");
	if(Pawn == None) {
		log("DYING, TRYAGAIN, Pawn == None");
		ReStartPlayer();
		Goto('TryAgain');
	} else {
		log("DYING, TRYAGAIN, Pawn != None");
		GotoState('StartUp');
	}
WaitingForStart:
	//bHidden = true;
	//bHidden = false;
	log("DYING, WAITINGFORSTART");
	Goto('Begin');
}

state Dead
{
ignores SeePlayer, HearNoise, KilledBy;

function BeginState()
{
	log("Dead, BeginState");

	//Revision:  12-9-05  Tim Garwood
	//This was commented out before, I will uncomment it and see if the server
	//restarts the player successfully.
	//BotDeathMatch(Level.Game).RestartPlayer( self );


        //ut2003 change - checking for certain game types now. if Level.Game is just one of either BotTeamGame/BotDeathMatch, etc
        //can't we just do Level.Game.RestartPlayer(self) ?
        // 1-30-06 TG
        if( Level.Game.isA('BotDeathMatch')) {
            BotDeathMatch(Level.Game).RestartPlayer( self );
        } else if( Level.Game.isA('BotTeamGame')) {
            BotTeamGame(Level.Game).RestartPlayer( self );
        } else if( Level.Game.isA('BotCTFGame')) {
            BotCTFGame(Level.Game).RestartPlayer( self );
        } else if( Level.Game.isA('BotDoubleDomGame')) {
            BotDoubleDomGame(Level.Game).RestartPlayer( self );
        } else if( Level.Game.isA('BotBombingRunGame')) {
            BotBombingRunGame(Level.Game).RestartPlayer( self );
        }

        ServerReStartPlayer();
}
}

//-------------RemoteBot Specific Functions--------------------


//Check to see if a location is really in front of the bot
//may be a more efficient algorithm
function bool inFront(Vector A)
{
	local rotator angle;

	//can't be infront if inside bot
          if( VSize(Pawn.Location - A) < CollisionRadius)
        	return false;

	angle = ( Pawn.Rotation - rotator(A - Pawn.Location) );

	if( (cos(angle.Yaw / 10435.0) < remoteVisionLimit) ||
		(cos(angle.Pitch / 10435.0) < remoteVisionLimit) )
		return false;
	else
		return true;
	
}


//Called by the gametype when someone else is injured by the bot
function int HurtOther(int Damage, name DamageType, pawn injured)
{
         //revision 2-20-06  Tim Garwood
        //sending unique player ID's and ID #'s for proper identification on the client side
	myConnection.SendLine("HIT" $ib$as$ "Id" $ib$ injured.Controller $ injured.Controller.PlayerReplicationInfo.PlayerID $ae$ib$as$
		"Damage" $ib$ Damage $ae$ib$as$
		"DamageType" $ib$ DamageType $ae);
}

function checkSelf()
{
	local int ArmorAmount,i;
	local inventory Inv;
	local string outstring;


        local string team; //2-1-06  The team that the bot, or whoever the bot is looking at, is on.
                           //used because the bots PRI Team object doesn't get set in BotDeathMatch, so we
                           //need to check for the gametype.
                           
         //we check for the gametype here and assign the team string accordingly.
        if(Level.Game.isA('BotDeathMatch')) {

          team = "Team 255";

        } else {
          team = "Team" $ib$ PlayerReplicationInfo.Team.TeamIndex;
        }

        /*
        if( Pawn.Weapon.Ammo[0] == none )
            log("Crap, Ammo[0] is none when self = " $self);
        */

	ArmorAmount = 0;
	i = 0;
	// [work]
	/*for( Inv=Inventory; Inv!=None; Inv=Inv.Inventory )
	{
		if (Inv.bIsAnArmor)
		{
			ArmorAmount += Inv.Charge;
		}
		else
		{ // FIXME
			i++;
			if ( i > 100 )
				break; // can occasionally get temporary loops in netplay
		}
	}*/

	//Revision: 12-12-05  Tim Garwood
	//added check to see if pawn was none, because pawn is set to none in PawnDied
	if( pawn != none ) {
	outstring = "SLF" $ib$as$ "Id" $ib$ self $ PlayerReplicationInfo.PlayerID $ae$ib$as$
	    "Rotation" $ib$ Pawn.Rotation $ae$ib$as$
	    "Location" $ib$ Pawn.Location $ae$ib$as$
	    "Velocity" $ib$ Pawn.Velocity $ae$ib$as$
	    "Name" $ib$ PlayerReplicationInfo.PlayerName $ae$ib$as$
	    team $ae$ib$as$
            //"Team" $ib$ PlayerReplicationInfo.Team.TeamIndex $ae$ib$as$
	    //Team works, but break the Java bot
	    "Health" $ib$ Pawn.Health $ae$ib$as$
	    "Weapon" $ib$ Pawn.Weapon $ae;

	// [work]

	if( Pawn.Weapon != None) {

	    //2-2-06 throws null pointer exception in ctf games, wtf?? deathmatch, TeamDM, BombingRun
            // and DoubleDom work with it...-TG
	    //FIXME!!!!!!!
            if( !Level.Game.isA('BotCTFGame')) {
	     outstring = outstring $ib$as$ "CurrentAmmo" $ib$ Pawn.Weapon.AmmoAmount(0) $ae;  //FIXME
            }


        }
	//	"Armor" $ib$ ArmorAmount $ae;
	//        ae;

	if( bFire != 0 )
	    outstring = outstring $ib$as$ "Firing" $ib$ "1" $ae;
	else if( bAltFire != 0 )
	    outstring = outstring $ib$as$ "AltFiring" $ib$ "2" $ae;
	else
	    outstring = outstring $ib$as$ "AltFiring" $ib$ "0" $ae;

	myConnection.sendLine(outstring);

	} else {

		log("PAWN IS NONE IN CHECKSELF - SHOULDN'T BE!!");

	}
}

function checkVision()
{
	local Inventory I;
	local Mover M;
	local Controller P;
	local CTFFlag C;
	local NavigationPoint N;
	local vector HitL, HitN;
	local int temp;
	local string outstring;

	local Pickup pickup;  //used to send information about pickup locations 2-23-06 TG

	//added 2-16-06  
	//used to send unique ID of the bot that is carrying the flag
	local Controller bombOrFlagCarrier;
	
        local xBombFlag bomb;
        local xBombDelivery deliveryHole;

	local string team; //2-1-06  The team that the bot, or whoever the bot is looking at, is on.
                           //used because the bots PRI Team object doesn't get set in BotDeathMatch, so we
                           //need to check for the gametype.

        //2-16-06  This loop is necessary because like CTF flags, bomb locations are not updated
        //by the engine when they are held, and checkVision is really the only function that gets called
        //frequently enough to have a good estimate of where the bomb is. - Tim Garwood
        foreach AllActors (class 'xBombFlag', bomb ) {

                if( bomb.getStateName() == 'Held')
                    bomb.setLocation( bomb.Holder.Location );
        }

        //yeah, so i guess this is kind of a hack...causes ctf flag to not really get rendered, probably
        //because we're updating the location so often.
        foreach AllActors (class 'CTFFlag', C ) {

                if( C.getStateName() == 'Held')
                    C.setLocation( C.Holder.Location );
        }



	//Revision: 12-12-05   Tim Garwood
	//'Accessed none' violation is getting thrown in this function because
	//whenever a bot dies, its pawn is set to null but we never check to see if
	//the bot is dead, so check for that first.

	if( pawn != none ) {

	//!!! view rotation sometimes falls out of synch with rotation? wtf?

	for ( P=Level.ControllerList; P!=None; P=P.NextController )
	{
	 //revision TG - inFront, Trace, etc. weren't returning 'true' when they should have
	 //been. CanSee, LineOfSightTo and FastTrace seem to do the job just fine.

	  if( P != self && CanSee(P.Pawn) && Pawn.LineOfSightTo( P.Pawn ) && Pawn.FastTrace(P.Pawn.Location))
           {

               //we check for the gametype here and assign the team string accordingly.
               if(Level.Game.isA('BotDeathMatch')) {

               team = "Team 255";

               } else {
                team = "Team" $ib$ PlayerReplicationInfo.Team.TeamIndex;
               }

               //need to send out a unique player Identification.
               //1-31-06 fixed Team ID # part of the outstring
                outstring = "PLR" $ib$as$ "Id" $ib$ P $ P.PlayerReplicationInfo.PlayerID $ae$ib$as$
	        "Rotation" $ib$ P.Pawn.Rotation $ae$ib$as$
                "Location" $ib$ P.Pawn.Location $ae$ib$as$
                "Velocity" $ib$ P.Pawn.Velocity $ae$ib$as$
                "Name" $ib$ P.PlayerReplicationInfo.PlayerName $ae$ib$as$
                team $ae$ib$as$
                //"Team" $ib$ P.PlayerReplicationInfo.Team.TeamIndex $ae$ib$as$
                "Reachable" $ib$ actorReachable(P.Pawn) $ae$ib$as$
                "Weapon" $ib$ P.Pawn.Weapon.Class $ae;

	         if( P.bFire != 0 )
			outstring = outstring $ib$as$ "Firing" $ib$ "1" $ae;
	         else if( P.bAltFire != 0 )
			outstring = outstring $ib$as$ "AltFiring" $ib$ "2" $ae;
	         else
	             outstring = outstring $ib$as$ "AltFiring" $ib$ "0" $ae;

                 myConnection.sendLine(outstring);
            }
	}

	//foreach VisibleCollidingActors(class'Inventory',I,Pawn.SightRadius)
	foreach AllActors(class'Pickup',pickup) {
    //2003/2004 UPDATED 4/4/2007 by Ian Tewksbury
    //Needed to use Pawn.Trace, not just Trace, see Tim's updated
    // below for more detail, think he just forgot to update this line.
		if( pickup.GetStateName() == 'Pickup'&& !pickup.bHidden && inFront(pickup.Location) &&
			( Pawn.Trace(HitL, HitN, pickup.Location) == none) )
		{
			myConnection.SendLine("INV" $ib$as$ "Id" $ib$ pickup $ae$ib$as$
				"Location" $ib$ pickup.Location $ae$ib$as$
				"Reachable" $ib$ actorReachable(pickup) $ae$ib$as$
				"Class" $ib$ pickup.Class $ae);
		}
	}

	//foreach VisibleCollidingActors(class'Mover',M,Pawn.SightRadius)
	foreach AllActors(class'Mover',M)
        {
		if( !M.bHidden && inFront(M.Location) &&
			Pawn.Trace(HitL, HitN, M.Location) == none)
		{
			myConnection.SendLine("MOV" $ib$as$ "Id" $ib$ M $ae$ib$as$
				"Location" $ib$ M.Location $ae$ib$as$
				"Reachable" $ib$ actorReachable(M) $ae$ib$as$
				"DamageTrig" $ib$ M.bDamageTriggered $ae$ib$as$
				"Class" $ib$ M.Class $ae);
		}
	}

	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
	{
		//try letting them see inv navpoints - may be needed for some levels
		//if( !N.IsA('InventorySpot') && FastTrace(N.Location) && inFront(N.Location))

	        //2003 change 2-10-06  Tim Garwood
	        //had to update the old conditional statement because it is never true in '03 for some reason
                //need to call FastTrace and Trace w/ pawn object since Controller is always at (0,0,0) ?
	        if( Pawn.FastTrace(N.Location) && inFront( N.Location ) && Pawn.Trace(HitL, HitN, N.Location) == none  ) {
		  // [work] dom stuff
			if(N.IsA('xDomPoint'))
			{
				if( xDomPoint(N).ControllingTeam == none )
					temp = 255;
				else
					temp = xDomPoint(N).ControllingTeam.TeamIndex;

                                outstring = "DOM" $ib$as$ "Id" $ib$ N $ae$ib$as$
					"Location" $ib$ N.Location $ae$ib$as$
					"Reachable" $ib$ actorReachable(N) $ae$ib$as$
					"Controller" $ib$ temp $ae;

				myConnection.SendLine( outstring );
			}
			else
				myConnection.SendLine("NAV" $ib$as$ "Id" $ib$ N $ae$ib$as$
					"Location" $ib$ N.Location $ae$ib$as$
					"Reachable" $ib$ actorReachable(N) $ae);
		}
	}

        //added 2-10-06  Tim Garwood
        //for ut200x BotBombingRunGame
	if (myConnection.Parent.gameClass == "BotBombingRunGame")
	{
		foreach AllActors (class'xBombFlag', bomb)
		{

		        if( Pawn.FastTrace(bomb.Location)) {
				outstring = "BOM" $ib$as$ "Id" $ib$ bomb $ae;
				if( bomb.GetStateName() == 'Held' && bomb.Holder != Pawn) {
				    bombOrFlagCarrier = bomb.Holder.Controller;

                                	outstring = outstring $ib$as$ "Location" $ib$ bomb.Holder.Location $ae$ib$as$
				             "Holder" $ib$ bombOrFlagCarrier $ bombOrFlagCarrier.PlayerReplicationInfo.PlayerID $ae$ib$as$
				             "Team"  $ib$ bomb.Holder.GetTeam().TeamIndex $ae;

                                }
				else
					outstring = outstring $ib$as$ "Location" $ib$ bomb.Location $ae;

				outstring = outstring $ib$as$ "Reachable" $ib$ actorReachable(bomb) $ae$ib$as$
						"State" $ib$ bomb.GetStateName() $ae;
                                myConnection.SendLine(outstring);
			}
		}

		foreach AllActors (class'xBombDelivery', deliveryHole)
		{
			if( Pawn.FastTrace(deliveryHole.Location) ) //&& inFront( deliveryHole.Location)
			{
				outstring = "HOL" $ib$as$ "Id" $ib$ deliveryHole.MyHole $ae$ib$as$
                                "Location" $ib$ deliveryHole.MyHole.Location $ae$ib$as$
                                "Reachable" $ib$ pointReachable( deliveryHole.MyHole.Location ) $ae$ib$as$
                                "Team" $ib$ deliveryHole.Team $ae;
                                myConnection.SendLine(outstring);
			}
		}
	}

	// [work] ctf stuff
	if (myConnection.Parent.gameClass == "BotCTFGame")
	{
		foreach AllActors (class'CTFFlag', C)
		{
			//not using trace because players tend to obstruct flags wildly
			if( Pawn.FastTrace(C.Location) && C.Holder != Pawn)
			{
				outstring = "FLG" $ib$as$ "Id" $ib$ C $ae;
				//when a flag is held its location is not updated by engine =(
				if( C.GetStateName() == 'Held') {

				    bombOrFlagCarrier = C.Holder.Controller;

                                	outstring = outstring $ib$as$ "Location" $ib$ C.Holder.Location $ae$ib$as$
                                             "Holder" $ib$ bombOrFlagCarrier $ bombOrFlagCarrier.PlayerReplicationInfo.PlayerID $ae;
				}
				else
					outstring = outstring $ib$as$ "Location" $ib$ C.Location $ae;

				outstring = outstring $ib$as$ "Team" $ib$ C.Team.TeamIndex $ae$ib$as$
						"Reachable" $ib$ actorReachable(C) $ae$ib$as$
						"State" $ib$ C.GetStateName() $ae;
                                myConnection.SendLine(outstring);
			}
		}
	}

	} else {
	
		log("PAWN IS NONE IN CHECKVISION - SHOULDN'T BE!!");
		
	}
}

//Shortten up the MakeItem calls
function string MakeItem(string first, string second)
{
	return myConnection.MakeItem(first,second);	
}

function Destroyed()
{
	
    if(Pawn != None) {
	Pawn.Destroy();
    }

    Super.Destroyed();
}

function ChangeWeapon()
{

}

function ServerChangedWeapon(Weapon OldWeapon, Weapon NewWeapon)
{

}

state MoveToGoal
{
	function BeginState();
}

//-----------------

defaultproperties
{
     remoteVisionLimit=0.707000
}





