/*
The Unreal Engine is protected under the GPL.
For more information, please see http://www.epicgames.com/ut2k4_eula.html
*/

//=============================================================================
// RemoteBotInfo.
//=============================================================================
//class RemoteBotInfo extends Info
class RemoteBotInfo extends UnrealMPGameInfo
	config(BotAPI);

var() 		 string VoiceType[64];
var() 		 string BotFaces[64];
var() config byte	Difficulty;

var() config string BotNames[64];
var() 		 int 	BotTeams[64];
var() config float  BotAccuracy;
var() config float  Alertness;
var	  		 byte   ConfigUsed[64];
var() 		 string BotClasses[64];
var() 		 string BotSkins[64];




function PreBeginPlay()
{
	//DON'T Call parent prebeginplay
}

function PostBeginPlay()
{
	local String NextBotClass, NextBotDesc;

	Super.PostBeginPlay();
}

function int GetBotTeam(int BotN)
{
	return BotTeams[BotN];	
}


function CHIndividualize(RemoteBot NewBot, int num)
{
	local int n;
	n = num % 64;

	// Set bot's skin
	//NewBot.Static.SetMultiSkin(NewBot, BotSkins[n], BotFaces[n], BotTeams[n]); // FIXME

        // Set bot's name.
	if ( (BotNames[n] == "") || (ConfigUsed[n] == 1) )
		BotNames[n] = "RemoteBotController";

	/*Level.Game.ChangeName( NewBot, BotNames[n], false ); // FIXME
	if ( BotNames[n] != NewBot.PlayerReplicationInfo.PlayerName )
		Level.Game.ChangeName( NewBot, ("RemoteBot"$NewBot), false);*/

	ConfigUsed[n] = 1;

	// adjust bot skill
	//NewBot.InitializeSkill(Difficulty);

	//NewBot.Accuracy = BotAccuracy;
	//NewBot.BaseAlertness = Alertness;


	/*if ( VoiceType[n] != "" && VoiceType[n] != "None" )
		NewBot.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(VoiceType[n], class'Class'));

	if(NewBot.PlayerReplicationInfo.VoiceType == None)
		NewBot.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(NewBot.VoiceType, class'Class'));*/
}

function int ChooseBotInfo()
{
	local int n;

	n = 0;

	while ( (n < 31) && (ConfigUsed[n] == 1) )
		n++;

	return n;
}

function class<RemoteBot> CHGetBotClass(int n)
{
    return class<RemoteBot>( DynamicLoadObject(BotClasses[n], class'Class') );
}

defaultproperties
{
     BotFaces(0)="CommandoSkins.Blake"
     BotFaces(1)="SGirlSkins.Aryss"
     BotFaces(2)="SoldierSkins.Malcom"
     BotFaces(3)="CommandoSkins.Luthor"
     BotFaces(4)="FCommandoSkins.Cryss"
     BotFaces(5)="FCommandoSkins.Visse"
     BotFaces(6)="SoldierSkins.Kregore"
     BotFaces(7)="SGirlSkins.Cilia"
     BotFaces(8)="CommandoSkins.Kragoth"
     BotFaces(9)="FCommandoSkins.Tanya"
     BotFaces(10)="SoldierSkins.Johnson"
     BotFaces(11)="CommandoSkins.Boris"
     BotFaces(12)="SGirlSkins.Vixen"
     BotFaces(13)="SGirlSkins.Sara"
     BotFaces(14)="SoldierSkins.Othello"
     BotFaces(15)="FCommandoSkins.Kyla"
     BotFaces(16)="CommandoSkins.Gorn"
     BotFaces(17)="SGirlSkins.Annaka"
     BotFaces(18)="SoldierSkins.Riker"
     BotFaces(19)="FCommandoSkins.Malise"
     BotFaces(20)="CommandoSkins.Ramirez"
     BotFaces(21)="FCommandoSkins.Freylis"
     BotFaces(22)="SoldierSkins.Arkon"
     BotFaces(23)="SGirlSkins.Sarena"
     BotFaces(24)="CommandoSkins.Grail"
     BotFaces(25)="FCommandoSkins.Mariana"
     BotFaces(26)="SoldierSkins.Rankin"
     BotFaces(27)="SGirlSkins.Isis"
     BotFaces(28)="CommandoSkins.Graves"
     BotFaces(29)="SGirlSkins.Lauren"
     BotFaces(30)="SoldierSkins.Malcom"
     BotFaces(31)="FCommandoSkins.Jayce"
     Difficulty=5
     BotNames(0)="Yigal"
     BotNames(1)="Paul"
     BotNames(2)="Jeff"
     BotNames(3)="Lewis"
     BotNames(4)="Milind"
     BotNames(5)="Ed"
     BotNames(6)="Daniel"
     BotNames(7)="Bill"
     BotNames(8)="Jim"
     BotNames(9)="Kevin"
     BotNames(10)="Stacy"
     BotNames(11)="Ulf"
     BotNames(12)="Randy"
     BotNames(13)="Yolanda"
     BotNames(14)="Wei-Min"
     BotNames(15)="Gal"
     BotNames(16)="Sheila"
     BotNames(17)="Andrew"
     BotNames(18)="David"
     BotNames(19)="Andrew M"
     BotNames(20)="Taylor"
     BotNames(21)="Aaron"
     BotNames(22)="Rogelio"
     BotNames(23)="Jay"
     BotNames(24)="Chon"
     BotNames(25)="Jihie"
     BotNames(26)="Jafar"
     BotNames(27)="Benamin"
     BotNames(28)="Mike"
     BotNames(29)="Jose Luis"
     BotNames(30)="Nico"
     BotNames(31)="Hans"
     BotTeams(0)=255
     BotTeams(2)=255
     BotTeams(3)=1
     BotTeams(4)=255
     BotTeams(5)=2
     BotTeams(6)=255
     BotTeams(7)=3
     BotTeams(8)=255
     BotTeams(10)=255
     BotTeams(11)=1
     BotTeams(12)=255
     BotTeams(13)=2
     BotTeams(14)=255
     BotTeams(15)=3
     BotTeams(16)=255
     BotTeams(18)=255
     BotTeams(19)=1
     BotTeams(20)=255
     BotTeams(21)=2
     BotTeams(22)=255
     BotTeams(23)=3
     BotTeams(24)=255
     BotTeams(26)=255
     BotTeams(27)=1
     BotTeams(28)=255
     BotTeams(29)=2
     BotTeams(30)=255
     BotTeams(31)=3
     BotAccuracy=0.500000
     Alertness=0.500000
     BotClasses(0)="BotAPI.RemoteBot"
     BotClasses(1)="BotAPI.RemoteBot"
     BotClasses(2)="BotAPI.RemoteBot"
     BotClasses(3)="BotAPI.RemoteBot"
     BotClasses(4)="BotAPI.RemoteBot"
     BotClasses(5)="BotAPI.RemoteBot"
     BotClasses(6)="BotAPI.RemoteBot"
     BotClasses(7)="BotAPI.RemoteBot"
     BotClasses(8)="BotAPI.RemoteBot"
     BotClasses(9)="BotAPI.RemoteBot"
     BotClasses(10)="BotAPI.RemoteBot"
     BotClasses(11)="BotAPI.RemoteBot"
     BotClasses(12)="BotAPI.RemoteBot"
     BotClasses(13)="BotAPI.RemoteBot"
     BotClasses(14)="BotAPI.RemoteBot"
     BotClasses(15)="BotAPI.RemoteBot"
     BotClasses(16)="BotAPI.RemoteBot"
     BotClasses(17)="BotAPI.RemoteBot"
     BotClasses(18)="BotAPI.RemoteBot"
     BotClasses(19)="BotAPI.RemoteBot"
     BotClasses(20)="BotAPI.RemoteBot"
     BotClasses(21)="BotAPI.RemoteBot"
     BotClasses(22)="BotAPI.RemoteBot"
     BotClasses(23)="BotAPI.RemoteBot"
     BotClasses(24)="BotAPI.RemoteBot"
     BotClasses(25)="BotAPI.RemoteBot"
     BotClasses(26)="BotAPI.RemoteBot"
     BotClasses(27)="BotAPI.RemoteBot"
     BotClasses(28)="BotAPI.RemoteBot"
     BotClasses(29)="BotAPI.RemoteBot"
     BotClasses(30)="BotAPI.RemoteBot"
     BotClasses(31)="BotAPI.RemoteBot"
     BotSkins(0)="CommandoSkins.cmdo"
     BotSkins(1)="SGirlSkins.fbth"
     BotSkins(2)="SoldierSkins.blkt"
     BotSkins(3)="CommandoSkins.daco"
     BotSkins(4)="FCommandoSkins.goth"
     BotSkins(5)="FCommandoSkins.goth"
     BotSkins(6)="SoldierSkins.RawS"
     BotSkins(7)="SGirlSkins.Venm"
     BotSkins(8)="CommandoSkins.goth"
     BotSkins(9)="FCommandoSkins.daco"
     BotSkins(10)="SoldierSkins.sldr"
     BotSkins(11)="CommandoSkins.daco"
     BotSkins(12)="SGirlSkins.Garf"
     BotSkins(13)="SGirlSkins.army"
     BotSkins(14)="SoldierSkins.blkt"
     BotSkins(15)="FCommandoSkins.daco"
     BotSkins(16)="CommandoSkins.cmdo"
     BotSkins(17)="SGirlSkins.fbth"
     BotSkins(18)="SoldierSkins.blkt"
     BotSkins(19)="FCommandoSkins.goth"
     BotSkins(20)="CommandoSkins.daco"
     BotSkins(21)="FCommandoSkins.goth"
     BotSkins(22)="SoldierSkins.RawS"
     BotSkins(23)="SGirlSkins.Venm"
     BotSkins(24)="CommandoSkins.goth"
     BotSkins(25)="FCommandoSkins.daco"
     BotSkins(26)="SoldierSkins.sldr"
     BotSkins(27)="SGirlSkins.Garf"
     BotSkins(28)="CommandoSkins.daco"
     BotSkins(29)="SGirlSkins.army"
     BotSkins(30)="SoldierSkins.blkt"
     BotSkins(31)="FCommandoSkins.daco"
}
