/*
The Unreal Engine is protected under the GPL.
For more information, please see http://www.epicgames.com/ut2k4_eula.html

Use and distribution of Gamebots is dictated by the terms in the GNU GPL.
http://www.gnu.org/licenses/gpl.html

Copyright 2006,  Jessica Bayliss
*/

//////////////////////////////////////////
//
// Class description: A server for getting 
// information about all game locations,
// characters, and items. Used for software
// that shows a birds-eye view of the map.
//
// Version: $Id$
//
// Revision: $Log$
//
/////////////////////////////////////////

class VizServer extends BotServerConnection;

////////////////////
//
// variables
//
////////////////////

// should be in the superclass, but it's used in some
// legacy code in FriendlyBots with a direct class path...
var string gameClass;

////////////////////
//
// Functions
//
////////////////////

// Called automagically
function BeginPlay()
{
  Super.BeginPlay();
  if(!bBound)
    {
      BindPort( ListenPort );
      if(bDebug)
	log("VizServer bound to port "$ListenPort);
      Listen();
      bBound = true;
    }
}

////////////////////
//
// Default properties
//
////////////////////

defaultproperties
{
     ListenPort=3001
     MaxConnections=4
     AcceptClass=Class'BotAPI.VizConnection'
}
